﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
namespace MultipleCheckBox
{
    public partial class Form1 : Form
    {
        C1FlexGrid grid;
        DataTable dt = new DataTable();
        IList<Row> selectedRowList;
        public Form1()
        {
            InitializeComponent();

            selectedRowList = new List<Row>();
            grid = new C1FlexGrid();
            grid.Dock = DockStyle.Fill;
            Controls.Add(grid);

            dt.Columns.Add("ID");
            dt.Columns.Add("Name");

            dt.Rows.Add(1, "A");
            dt.Rows.Add(2, "B");
            dt.Rows.Add(3, "C");
            dt.Rows.Add(4, "D");
            dt.Rows.Add(5, "E");
            dt.Rows.Add(6, "F");
            dt.Rows.Add(7, "G");
            dt.Rows.Add(8, "H");
            grid.DataSource = dt;
            
            for(int row = 0; row < grid.Rows.Count; row++)
                grid.SetCellCheck(row, 0, CheckEnum.Unchecked);

            for (int column = 1; column < grid.Cols.Count - 1; column++)
                grid.Cols[column].AllowEditing = false;

            grid.AfterEdit += Grid_AfterEdit;
        }

        private void Grid_AfterEdit(object sender, RowColEventArgs e)
        {
            Console.WriteLine("AfterEdit");
            if (e.Row == 0 && e.Col == 0)
                ChangeState(grid.GetCellCheck(e.Row, e.Col));
            else
            {
                if (grid.GetCellCheck(e.Row, 0) == CheckEnum.Checked)
                    selectedRowList.Add(grid.Rows[e.Row]);
                else
                {
                    grid.SetCellCheck(0, 0, CheckEnum.Grayed);
                    selectedRowList.Remove(grid.Rows[e.Row]);
                }
            }
            //can access the selectedRowList to get the list of selected rows.
        }
        void ChangeState(CheckEnum state)
        {
            selectedRowList.Clear();
            for(int row = grid.Rows.Fixed; row < grid.Rows.Count; row++)
            {
                grid.SetCellCheck(row, 0, state);
                if (state == CheckEnum.Checked)
                    selectedRowList.Add(grid.Rows[row]);
            }
        }
    }
}
